// hlavickove subory *******************************************************
#include "common/includes.h"
// vlastny .h subor
#include "frontend.h"

// konstruktor *************************************************************
CFrontend::CFrontend()
{

}

// destruktor **************************************************************
CFrontend::~CFrontend()
{

}

// vykreslenie vsetkych trojuholnikov **************************************
void CFrontend::tris_draw(void)
{
 // ulozenie potrebnych atributov
 glPushAttrib(GL_TEXTURE_BIT);

 // 1. texturovacia jednotka
 glActiveTextureARB(GL_TEXTURE0_ARB);
 glEnable(GL_TEXTURE_2D);
 // 2. texturovacia jednotka
 glActiveTextureARB(GL_TEXTURE1_ARB);
 glEnable(GL_TEXTURE_2D);
 // kombinacna funkcia
 glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_COMBINE_EXT);
 glTexEnvi(GL_TEXTURE_ENV,GL_COMBINE_RGB_EXT,GL_MODULATE);

 // identifikator aktualnej textury a lightmapy
 act_tex_id=0; act_lm_id=0;
 // pre vsetky trojuholniky
 loopvk(tris) {
  // pouzije sa multitexturing, 1. textura - original, 2. textura - lightmapa
  // ak je potrebne vymenit aktualnu texturu
  if (act_tex_id!=tris[k].tex1id) {
   act_tex_id=tris[k].tex1id;
   glActiveTextureARB(GL_TEXTURE0_ARB);
   glBindTexture(GL_TEXTURE_2D,tris[k].tex1id);
  }
  // ak je potrebne vymenit aktualnu lightmapu
  if (act_lm_id!=tris[k].lmid) {
   act_lm_id=tris[k].lmid;
   glActiveTextureARB(GL_TEXTURE1_ARB);
   glBindTexture(GL_TEXTURE_2D,tris[k].lmid);
  }

  // farba
  //glColor4f(tris[k].c.x,tris[k].c.y,tris[k].c.z,tris[k].c.w);

  // vykreslenie trojuholnika
  glBegin(GL_TRIANGLES);
   glNormal3f(tris[k].vn[0].x,tris[k].vn[0].y,tris[k].vn[0].z);
   glMultiTexCoord2fARB(GL_TEXTURE0_ARB,tris[k].t[0].x,tris[k].t[0].y);
   glMultiTexCoord2fARB(GL_TEXTURE1_ARB,tris[k].l[0].x,tris[k].l[0].y);
   glVertex3f(tris[k].v[0].x,tris[k].v[0].y,tris[k].v[0].z);

   glNormal3f(tris[k].vn[1].x,tris[k].vn[1].y,tris[k].vn[1].z);
   glMultiTexCoord2fARB(GL_TEXTURE0_ARB,tris[k].t[1].x,tris[k].t[1].y);
   glMultiTexCoord2fARB(GL_TEXTURE1_ARB,tris[k].l[1].x,tris[k].l[1].y);
   glVertex3f(tris[k].v[1].x,tris[k].v[1].y,tris[k].v[1].z);

   glNormal3f(tris[k].vn[2].x,tris[k].vn[2].y,tris[k].vn[2].z);
   glMultiTexCoord2fARB(GL_TEXTURE0_ARB,tris[k].t[2].x,tris[k].t[2].y);
   glMultiTexCoord2fARB(GL_TEXTURE1_ARB,tris[k].l[2].x,tris[k].l[2].y);
   glVertex3f(tris[k].v[2].x,tris[k].v[2].y,tris[k].v[2].z);
  glEnd();
/*
  // INFO: vykreslenie normal a koliznych normal
  glPushAttrib(GL_TEXTURE_BIT);
  glDisable(GL_TEXTURE_2D);

  glColor4f(1.0f,0.0f,0.0f,1.0f); // normaly - cervenou

  glBegin(GL_LINES);
   glVertex3f(tris[k].v[0].x,tris[k].v[0].y,tris[k].v[0].z);
   glVertex3f(tris[k].v[0].x+tris[k].vn[0].x,tris[k].v[0].y+tris[k].vn[0].y,tris[k].v[0].z+tris[k].vn[0].z);

   glVertex3f(tris[k].v[1].x,tris[k].v[1].y,tris[k].v[1].z);
   glVertex3f(tris[k].v[1].x+tris[k].vn[1].x,tris[k].v[1].y+tris[k].vn[1].y,tris[k].v[1].z+tris[k].vn[1].z);

   glVertex3f(tris[k].v[2].x,tris[k].v[2].y,tris[k].v[2].z);
   glVertex3f(tris[k].v[2].x+tris[k].vn[2].x,tris[k].v[2].y+tris[k].vn[2].y,tris[k].v[2].z+tris[k].vn[2].z);
  glEnd();

  glColor4f(1.0f,1.0f,0.0f,1.0f); // kolizne normaly - zltou

  glBegin(GL_LINES);
   glVertex3f(tris[k].v[0].x,tris[k].v[0].y,tris[k].v[0].z);
   glVertex3f(tris[k].v[0].x+tris[k].cn[0].x,tris[k].v[0].y+tris[k].cn[0].y,tris[k].v[0].z+tris[k].cn[0].z);

   glVertex3f(tris[k].v[1].x,tris[k].v[1].y,tris[k].v[1].z);
   glVertex3f(tris[k].v[1].x+tris[k].cn[1].x,tris[k].v[1].y+tris[k].cn[1].y,tris[k].v[1].z+tris[k].cn[1].z);

   glVertex3f(tris[k].v[2].x,tris[k].v[2].y,tris[k].v[2].z);
   glVertex3f(tris[k].v[2].x+tris[k].cn[2].x,tris[k].v[2].y+tris[k].cn[2].y,tris[k].v[2].z+tris[k].cn[2].z);
  glEnd();

  // standardna farba - biela
  glColor4f(1.0f,1.0f,1.0f,1.0f);

  glPopAttrib();
*/
 }

 // 2. texturovacia jednotka
 glActiveTextureARB(GL_TEXTURE1_ARB);
 glDisable(GL_TEXTURE_2D);
 // 1. texturovacia jednotka
 glActiveTextureARB(GL_TEXTURE0_ARB);
/*
 // INFO: zobrazenie obsahu 1. lightmapy
 glBindTexture(GL_TEXTURE_2D,tris[0].lmid);
 glBegin(GL_QUADS);
  glTexCoord2f(0.0f,0.0f); glVertex3f(0.0f,0.0f,0.0f);
  glTexCoord2f(1.0f,0.0f); glVertex3f(1.0f,0.0f,0.0f);
  glTexCoord2f(1.0f,1.0f); glVertex3f(1.0f,1.0f,0.0f);
  glTexCoord2f(0.0f,1.0f); glVertex3f(0.0f,1.0f,0.0f);
 glEnd();
*/
 // nastavenie standardnej farby - biela
 //glColor4f(1.0f,1.0f,1.0f,1.0f);

 glPopAttrib(); // vyber ulozenych atributov - TEXTURE
}
